﻿// Copyright (C) Microsoft. All rights reserved. 
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices; // Need for Filzbach
using Microsoft.Research.Science.Data; // Need for Scientific DataSet
using Microsoft.Research.Science.Data.Imperative; // Need for Scientific DataSet
using Microsoft.Research.Science.Data.Climate.Conventions; // Need for FetchClimate

using FilzbachInterop; // Need for Filzbach

namespace CSToolsCodeTemplate
{
    public class BlankClass : ModelBase
    {
        public BlankClass() : base("BlankClass") { }

        [FilzbachParameter(lb: 0, ub: 1, val: 0.5, type: 0, @fixed: 0, dsply: 1)]
        public double a { get; set; }

        /// <summary>
        /// The function used to make the model predictions to be compared with observations and assess the likelihood
        /// </summary>
        /// <param name="SiteData">The dataset used to provide environmental data</param>
        /// <returns>A double array of predictions</returns>
        public override double EstimatePredictionsAndLikelihood(DataSet SiteData)
        {
            double likelihood = 0.0;

            return likelihood;
        }

        /// <summary>
        /// Used to identify the dataset to use
        /// </summary>
        /// <param name="fileName">the name of the file... not used in this case</param>
        /// <returns></returns>
        public override DataSet MakeData(string fileName)
        {
            DataSet SourceData = DataSet.Open(fileName + ".csv");
            return SourceData;
        }
    }
}
